import ownerWindow from "./ownerWindow";

const getStyleValue = value => {
  return parseInt(value, 10) || 0;
};

const getSizingData = node => {
  const containerWindow = ownerWindow(node);
  const computedStyle = containerWindow.getComputedStyle(node);

  if (computedStyle === null) {
    return null;
  }

  const boxSizing = computedStyle.boxSizing;
  const paddingSize = getStyleValue(computedStyle.paddingBottom) + getStyleValue(computedStyle.paddingTop);
  const borderSize = getStyleValue(computedStyle.borderBottomWidth) + getStyleValue(computedStyle.borderTopWidth);
  return {
    boxSizing,
    paddingSize,
    borderSize,
    containerWindow,
    computedStyle
  };
};

export default getSizingData;