const updateState = (prevState, newState, renderRef) => {
  const {
    height,
    overflow
  } = newState;
  const renders = renderRef; // Need a large enough difference to update the height.
  // This prevents infinite rendering loop.

  if (renders.current < 20 && (height > 0 && Math.abs((prevState.height || 0) - height) > 1 || prevState.overflow !== overflow)) {
    renders.current += 1;
    return {
      overflow,
      height
    };
  } // if (process.env.NODE_ENV !== "production") {
  //   if (renders.current === 20) {
  //     console.error(
  //       [
  //         "MUI: Too many re-renders. The layout is unstable.",
  //         "TextareaAutosize limits the number of renders to prevent an infinite loop."
  //       ].join("\n")
  //     )
  //   }
  // }


  return prevState;
};

export default updateState;