"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _debounce = _interopRequireDefault(require("./utils/debounce"));

var _calculateNodeHeight2 = _interopRequireDefault(require("./utils/calculateNodeHeight"));

var _ownerWindow = _interopRequireDefault(require("./utils/ownerWindow"));

var _updateState = _interopRequireDefault(require("./utils/updateState"));

var _TextareaModule = _interopRequireDefault(require("./Textarea.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Textarea = /*#__PURE__*/function (_React$Component) {
  _inherits(Textarea, _React$Component);

  var _super = _createSuper(Textarea);

  function Textarea(props) {
    var _this;

    _classCallCheck(this, Textarea);

    _this = _super.call(this, props);
    _this.hiddenTextareaRef = /*#__PURE__*/_react["default"].createRef();
    _this.rendersRef = /*#__PURE__*/_react["default"].createRef();
    _this.sizingData = /*#__PURE__*/_react["default"].createRef(null);
    _this.rAF = null;
    _this.resizeObserver = null;
    _this.debounceHandleResize = null;
    _this.onBlur = _this.onBlur.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    _this.inputRef = _this.inputRef.bind(_assertThisInitialized(_this));
    _this.isEmpty = _this.isEmpty.bind(_assertThisInitialized(_this));
    _this.syncHeight = _this.syncHeight.bind(_assertThisInitialized(_this));
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.handleResize = _this.handleResize.bind(_assertThisInitialized(_this));
    _this.rAFHandleResize = _this.rAFHandleResize.bind(_assertThisInitialized(_this));
    _this.mountingPhase = _this.mountingPhase.bind(_assertThisInitialized(_this));
    _this.unMountingPhase = _this.unMountingPhase.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Textarea, [{
    key: "onBlur",
    value: function onBlur(e) {
      e && e.preventDefault();
      var onBlur = this.props.onBlur;
      onBlur && onBlur(e.target.value, e);
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;
      onKeyDown && onKeyDown(e);
    }
  }, {
    key: "inputRef",
    value: function inputRef(e) {
      var getRef = this.props.getRef;
      this.textareaRef = e;
      getRef && getRef(e);
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(obj) {
      return obj === undefined || obj === null || Object.keys(obj).length === 0 || obj.height === 0 && !obj.overflow;
    }
  }, {
    key: "syncHeight",
    value: function syncHeight() {
      var _this$props = this.props,
          minRows = _this$props.minRows,
          maxRows = _this$props.maxRows;

      var _calculateNodeHeight = (0, _calculateNodeHeight2["default"])({
        minRows: minRows,
        maxRows: maxRows,
        textareaEle: this.textareaRef,
        hiddenTextareaEle: this.hiddenTextareaRef.current
      }),
          height = _calculateNodeHeight.height,
          overflow = _calculateNodeHeight.overflow;

      var newState = {
        height: height,
        overflow: overflow
      };

      if (this.isEmpty(newState)) {
        return;
      }

      this.sizingData.current = (0, _updateState["default"])(this.sizingData.current, newState, this.rendersRef); // this.textareaRef.style.setProperty('height',`${this.sizingData.current.height}px`);

      this.textareaRef.style.height = "".concat(this.sizingData.current.height, "px");
      this.textareaRef.style.overflowY = "".concat(this.sizingData.current.overflow ? 'hidden' : 'auto');
    }
  }, {
    key: "onChange",
    value: function onChange(e) {
      var _this2 = this;

      e && e.preventDefault();
      var onChange = this.props.onChange;
      this.rendersRef.current = 0;
      var value = e.target.value;
      requestAnimationFrame(function () {
        _this2.syncHeight();

        onChange && onChange(value, e);
      });
    }
  }, {
    key: "handleResize",
    value: function handleResize() {
      this.rendersRef.current = 0;
      this.syncHeight();
    }
  }, {
    key: "rAFHandleResize",
    value: function rAFHandleResize() {
      var _this3 = this;

      cancelAnimationFrame(this.rAF);
      this.rAF = requestAnimationFrame(function () {
        _this3.handleResize();
      });
    }
  }, {
    key: "mountingPhase",
    value: function mountingPhase() {
      var input = this.textareaRef;
      var containerWindow = (0, _ownerWindow["default"])(input);
      this.debounceHandleResize = (0, _debounce["default"])(this.handleResize);
      containerWindow.addEventListener("resize", this.debounceHandleResize);

      if (typeof ResizeObserver !== "undefined") {
        this.resizeObserver = new ResizeObserver(this.rAFHandleResize);
        this.resizeObserver.observe(input);
      }
    }
  }, {
    key: "unMountingPhase",
    value: function unMountingPhase() {
      var input = this.textareaRef;
      var containerWindow = (0, _ownerWindow["default"])(input);
      this.debounceHandleResize.clear();
      cancelAnimationFrame(this.rAF);
      containerWindow.removeEventListener("resize", this.debounceHandleResize);

      if (this.resizeObserver) {
        this.resizeObserver.disconnect();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.sizingData.current = {
        height: 0,
        overflow: false
      };
      this.mountingPhase();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.sizingData.current = null;
      this.unMountingPhase();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.text !== this.props.text) {
        this.rendersRef.current = 0;
        this.syncHeight();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          size = _this$props2.size,
          placeHolder = _this$props2.placeHolder,
          needBorder = _this$props2.needBorder,
          text = _this$props2.text,
          isDisabled = _this$props2.isDisabled,
          resize = _this$props2.resize,
          maxLength = _this$props2.maxLength,
          animated = _this$props2.animated,
          variant = _this$props2.variant,
          getRef = _this$props2.getRef,
          onFocus = _this$props2.onFocus,
          dataId = _this$props2.dataId,
          dataSelectorId = _this$props2.dataSelectorId,
          isReadOnly = _this$props2.isReadOnly,
          needAppearance = _this$props2.needAppearance,
          needReadOnlyStyle = _this$props2.needReadOnlyStyle,
          borderColor = _this$props2.borderColor,
          needEffect = _this$props2.needEffect,
          autoFocus = _this$props2.autoFocus,
          htmlId = _this$props2.htmlId,
          a11y = _this$props2.a11y,
          customClass = _this$props2.customClass,
          minRows = _this$props2.minRows;
      var ariaLabel = a11y.ariaLabel,
          ariaLabelledby = a11y.ariaLabelledby;
      var resizes = {
        horizontal: "resizeX",
        vertical: "resizeY",
        both: "resizeboth",
        none: "noresize"
      };
      var options = {};

      if (isReadOnly) {
        options.readOnly = "readOnly";
      }

      if (isDisabled) {
        options.disabled = "disabled";
      }

      if (autoFocus) {
        options.autoFocus = true;
      }

      var classList = needAppearance ? "".concat(_TextareaModule["default"].container, " ").concat(_TextareaModule["default"][size], " ").concat(_TextareaModule["default"][variant], " ").concat(needBorder ? _TextareaModule["default"].needBorder : _TextareaModule["default"].noBorder, " ").concat(resize ? _TextareaModule["default"][resizes[resize]] : _TextareaModule["default"][resizes.none], "  ").concat(animated ? "".concat(_TextareaModule["default"]["".concat(size, "animated")]) : "", "   ").concat(isDisabled && !needEffect || isReadOnly && !needEffect ? "" : _TextareaModule["default"].effect) : "".concat(_TextareaModule["default"].basic);
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("textarea", _extends({
        "aria-label": ariaLabel,
        "aria-labelledby": ariaLabelledby,
        className: "".concat(customClass, " ").concat(isReadOnly && needReadOnlyStyle ? _TextareaModule["default"].readonly : "", " ").concat(classList, " ").concat(_TextareaModule["default"]["borderColor_".concat(borderColor)]),
        placeholder: placeHolder
      }, options, {
        "data-id": dataId,
        "data-test-id": dataId,
        maxLength: maxLength,
        onChange: this.onChange,
        onKeyDown: this.onKeyDown,
        onFocus: onFocus,
        onBlur: this.onBlur,
        ref: this.inputRef,
        value: text,
        id: htmlId,
        "data-selector-id": dataSelectorId,
        rows: minRows
      })), /*#__PURE__*/_react["default"].createElement("textarea", {
        "aria-hidden": true,
        readOnly: true,
        ref: this.hiddenTextareaRef,
        tabIndex: -1,
        className: "".concat(customClass, " ").concat(isReadOnly && needReadOnlyStyle ? _TextareaModule["default"].readonly : "", " ").concat(classList, " ").concat(_TextareaModule["default"]["borderColor_".concat(borderColor)], " ").concat(_TextareaModule["default"].forceHiddenStyle)
      }));
    }
  }]);

  return Textarea;
}(_react["default"].Component);

exports["default"] = Textarea;
Textarea.defaultProps = _defaultProps.defaultProps;
Textarea.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   Textarea.docs = {
//     componentGroup: 'Form Elements',
//     folderName: 'Style Guide',
//     external: true,
//     description: ' '
//   };
// }