"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ownerWindow = _interopRequireDefault(require("./ownerWindow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var getStyleValue = function getStyleValue(value) {
  return parseInt(value, 10) || 0;
};

var getSizingData = function getSizingData(node) {
  var containerWindow = (0, _ownerWindow["default"])(node);
  var computedStyle = containerWindow.getComputedStyle(node);

  if (computedStyle === null) {
    return null;
  }

  var boxSizing = computedStyle.boxSizing;
  var paddingSize = getStyleValue(computedStyle.paddingBottom) + getStyleValue(computedStyle.paddingTop);
  var borderSize = getStyleValue(computedStyle.borderBottomWidth) + getStyleValue(computedStyle.borderTopWidth);
  return {
    boxSizing: boxSizing,
    paddingSize: paddingSize,
    borderSize: borderSize,
    containerWindow: containerWindow,
    computedStyle: computedStyle
  };
};

var _default = getSizingData;
exports["default"] = _default;